# MapServer

## Build

```bash
docker build -t gitlab.ssec.wisc.edu:5555/cspp_geo/cspp-geo-web-viewer/mapserver:latest mapserver/
```

## Usage

```bash
docker run -p 8888:80 -d --rm --name cspp-geo-mapserver --network cspp-geo-rabbit -v cspp-geo-abi-l1b-geotiffs:/data gitlab.ssec.wisc.edu:5555/cspp_geo/cspp-geo-web-viewer/mapserver:latest
```

Then the main mapserv CGI script can be accessed with:

http://localhost:8888/cgi-bin/mapserv

where MapServer parameters can be appended to the end (after a `?`). However,
an easier to access API is available:

```bash
http://localhost:8888/wms/<satellite>/<instrument>/<sector>/<data_level>?...
```

An example URL of this including MapServer parameters is:

```bash
http://localhost:8888/wms/g16/abi/radf/l1b?request=GetMap&service=WMS&version=1.1.1&srs=EPSG:930916&layers=true_color_test&bbox=-5000000,-5000000,5000000,5000000&format=image/png&WIDTH=1000&HEIGHT=1000&TIME=2020-01-21T16:00:16
```

## Special Notes

This image has had its installation of the PROJ library modified to include
new non-standard EPSG codes to support the projections of certain satellite
instruments. These additions are part of the Dockerfile build process and
include the following definitions:

1. EPSG:930916 - The GOES-16 ABI Fixed Grid geostationary coordinate reference
   system. The numbers are meant to represent "GEOG16" while also attempting
   to avoid conflicts with future additions to the official EPSG database.
2. EPSG:930917 - The GOES-17 ABI Fixed Grid geostationary coordinate reference
   system. The numbers are meant to represent "GEOG17" while also attempting
   to avoid conflicts with future additions to the official EPSG database.
